Index: palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- palm/trunk/SOURCE/init_3d_model.f90	(revision 4901)
+++ palm/trunk/SOURCE/init_3d_model.f90	(revision 1)
@@ -1722,291 +953,27 @@
     sr = statistic_regions + 1
 #if defined( __parallel )
-    IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-    CALL MPI_ALLREDUCE( ngp_2dh_l(0), ngp_2dh(0), sr, MPI_INTEGER, MPI_SUM, comm2d, ierr )
-    IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-    CALL MPI_ALLREDUCE( ngp_2dh_outer_l(0,0), ngp_2dh_outer(0,0), (nz+2)*sr, MPI_INTEGER, MPI_SUM, &
+    CALL MPI_ALLREDUCE( ngp_2dh_l(0), ngp_2dh(0), sr, MPI_INTEGER, MPI_SUM,  &
                         comm2d, ierr )
-    IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-    CALL MPI_ALLREDUCE( ngp_2dh_s_inner_l(0,0), ngp_2dh_s_inner(0,0), (nz+2)*sr, MPI_INTEGER,      &
+    CALL MPI_ALLREDUCE( ngp_2dh_outer_l(0,0), ngp_2dh_outer(0,0), (nz+2)*sr, &
+                        MPI_INTEGER, MPI_SUM, comm2d, ierr )
+    CALL MPI_ALLREDUCE( ngp_3d_inner_l(0), ngp_3d_inner(0), sr, MPI_INTEGER, &
                         MPI_SUM, comm2d, ierr )
-    IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-    CALL MPI_ALLREDUCE( ngp_3d_inner_l(0), ngp_3d_inner_tmp(0), sr, MPI_REAL, MPI_SUM, comm2d,     &
-                        ierr )
-    ngp_3d_inner = INT( ngp_3d_inner_tmp, KIND = SELECTED_INT_KIND( 18 ) )
-    IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-    CALL MPI_ALLREDUCE( mean_surface_level_height_l(0), mean_surface_level_height(0), sr, MPI_REAL,&
-                        MPI_SUM, comm2d, ierr )
-    mean_surface_level_height = mean_surface_level_height / REAL( ngp_2dh )
 #else
-    ngp_2dh         = ngp_2dh_l
-    ngp_2dh_outer   = ngp_2dh_outer_l
-    ngp_2dh_s_inner = ngp_2dh_s_inner_l
-    ngp_3d_inner    = INT( ngp_3d_inner_l, KIND = SELECTED_INT_KIND( 18 ) )
-    mean_surface_level_height = mean_surface_level_height_l / REAL( ngp_2dh_l )
+    ngp_2dh       = ngp_2dh_l
+    ngp_2dh_outer = ngp_2dh_outer_l
+    ngp_3d_inner  = ngp_3d_inner_l
 #endif
 
-    ngp_3d = INT ( ngp_2dh, KIND = SELECTED_INT_KIND( 18 ) ) *                                     &
-             INT ( (nz + 2 ), KIND = SELECTED_INT_KIND( 18 ) )
-
-!
-!-- Set a lower limit of 1 in order to avoid zero divisions in flow_statistics, buoyancy, etc. A
-!-- zero value will occur for cases where all grid points of the respective subdomain lie below the
-!-- surface topography
-    ngp_2dh_outer   = MAX( 1, ngp_2dh_outer(:,:)   )
-    ngp_3d_inner    = MAX( INT(1, KIND = SELECTED_INT_KIND( 18 )), ngp_3d_inner(:) )
-    ngp_2dh_s_inner = MAX( 1, ngp_2dh_s_inner(:,:) )
-
-    DEALLOCATE( mean_surface_level_height_l, ngp_2dh_l, ngp_2dh_outer_l, ngp_3d_inner_l,           &
-                ngp_3d_inner_tmp )
-
-!
-!-- Initializae 3D offline nesting in COSMO model and read data from
-!-- external NetCDF file.
-    IF ( nesting_offline )  CALL nesting_offl_init
-!
-!-- Initialize quantities for special advections schemes
-    CALL init_advec
-
-!
-!-- Impose random perturbation on the horizontal velocity field and then
-!-- remove the divergences from the velocity field at the initial stage
-    IF ( create_disturbances  .AND.  disturbance_energy_limit /= 0.0_wp  .AND.                     &
-         TRIM( initializing_actions ) /= 'read_restart_data'  .AND.                                &
-         TRIM( initializing_actions ) /= 'cyclic_fill' )  THEN
-
-       IF ( debug_output )  THEN
-          CALL debug_message( 'creating disturbances + applying pressure solver', 'start' )
-       ENDIF
-!
-!--    Needed for both disturb_field and pres
-!$ACC DATA &
-!$ACC CREATE(tend(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
-!$ACC COPY(u(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
-!$ACC COPY(v(nzb:nzt+1,nysg:nyng,nxlg:nxrg))
-
-       CALL disturb_field( 'u', tend, u )
-       CALL disturb_field( 'v', tend, v )
-
-!$ACC DATA &
-!$ACC CREATE(d(nzb+1:nzt,nys:nyn,nxl:nxr)) &
-!$ACC COPY(w(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
-!$ACC COPY(p(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
-!$ACC COPYIN(rho_air(nzb:nzt+1), rho_air_zw(nzb:nzt+1)) &
-!$ACC COPYIN(ddzu(1:nzt+1), ddzw(1:nzt+1)) &
-!$ACC COPYIN(wall_flags_total_0(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
-!$ACC COPYIN(bc_h(0:1)) &
-!$ACC COPYIN(bc_h(0)%i(1:bc_h(0)%ns)) &
-!$ACC COPYIN(bc_h(0)%j(1:bc_h(0)%ns)) &
-!$ACC COPYIN(bc_h(0)%k(1:bc_h(0)%ns)) &
-!$ACC COPYIN(bc_h(1)%i(1:bc_h(1)%ns)) &
-!$ACC COPYIN(bc_h(1)%j(1:bc_h(1)%ns)) &
-!$ACC COPYIN(bc_h(1)%k(1:bc_h(1)%ns))
-
-       n_sor = nsor_ini
-       CALL pres
-       n_sor = nsor
-
-!$ACC END DATA
-!$ACC END DATA
-
-       IF ( debug_output )  THEN
-          CALL debug_message( 'creating disturbances + applying pressure solver', 'end' )
-       ENDIF
-
-    ENDIF
-
-    IF ( .NOT. ocean_mode )  THEN
-
-       ALLOCATE( hyp(nzb:nzt+1) )
-       ALLOCATE( d_exner(nzb:nzt+1) )
-       ALLOCATE( exner(nzb:nzt+1) )
-       ALLOCATE( hyrho(nzb:nzt+1) )
-!
-!--    Check temperature in case of too large domain height
-       DO  k = nzb, nzt+1
-          IF ( ( pt_surface * exner_function( surface_pressure * 100.0_wp ) - g/c_p * zu(k) )      &
-                 < 0.0_wp )  THEN
-             WRITE( message_string, * )  'absolute temperature < 0.0 at zu(', k, ') = ', zu(k)
-             CALL message( 'init_3d_model', 'PA0142', 1, 2, 0, 6, 0 )
-          ENDIF
-       ENDDO
-
-!
-!--    Calculate vertical profile of the hydrostatic pressure (hyp)
-       hyp    = barometric_formula( zu, pt_surface * exner_function( surface_pressure * 100.0_wp ),&
-                                    surface_pressure * 100.0_wp )
-       d_exner = exner_function_invers( hyp )
-       exner = 1.0_wp / exner_function_invers( hyp )
-       hyrho  = ideal_gas_law_rho_pt( hyp, pt_init )
-!
-!--    Compute reference density
-       rho_surface = ideal_gas_law_rho( surface_pressure * 100.0_wp,                               &
-                                        pt_surface * exner_function( surface_pressure * 100.0_wp ) )
-
-    ENDIF
-
-!
-!-- If required, initialize particles
-    IF ( agents_active )  CALL mas_init
-!
-!-- Initialization of synthetic turbulence generator
-    IF ( syn_turb_gen )  CALL stg_init
-!
-!-- Initializing actions for all other modules
-    CALL module_interface_init
-!
-!-- Initialize surface layer (done after LSM as roughness length are required for initialization
-    IF ( constant_flux_layer )  CALL init_surface_layer_fluxes
-!
-!-- Initialize surface data output
-    IF ( surface_output )  CALL surface_data_output_init
-!
-!-- Initialize the ws-scheme.
-    IF ( ws_scheme_sca  .OR.  ws_scheme_mom )  CALL ws_init
-!
-!-- Perform post-initializing checks for all other modules
-    CALL module_interface_init_checks
-
-!
-!-- Initialize surface forcing corresponding to large-scale forcing. Therein,
-!-- initialize heat-fluxes, etc. via datatype. Revise it later!
-    IF ( large_scale_forcing  .AND.  lsf_surf )  THEN
-       IF ( use_surface_fluxes  .AND.  constant_heatflux )  THEN
-          CALL ls_forcing_surf( simulated_time )
-       ENDIF
-    ENDIF
-!
-!-- Setting weighting factors for calculation of perturbation pressure and turbulent quantities from
-!-- the RK substeps.
-    IF ( TRIM( timestep_scheme ) == 'runge-kutta-3' )  THEN      ! for RK3-method
-
-       weight_substep(1) = 1._wp/6._wp
-       weight_substep(2) = 3._wp/10._wp
-       weight_substep(3) = 8._wp/15._wp
-
-       weight_pres(1)    = 1._wp/3._wp
-       weight_pres(2)    = 5._wp/12._wp
-       weight_pres(3)    = 1._wp/4._wp
-
-    ELSEIF ( TRIM( timestep_scheme ) == 'runge-kutta-2' )  THEN  ! for RK2-method
-
-       weight_substep(1) = 1._wp/2._wp
-       weight_substep(2) = 1._wp/2._wp
-
-       weight_pres(1)    = 1._wp/2._wp
-       weight_pres(2)    = 1._wp/2._wp
-
-    ELSE                                     ! for Euler-method
-
-       weight_substep(1) = 1.0_wp
-       weight_pres(1)    = 1.0_wp
-
-    ENDIF
-
-!
-!-- Initialize Rayleigh damping factors
-    rdf    = 0.0_wp
-    rdf_sc = 0.0_wp
-    IF ( rayleigh_damping_factor /= 0.0_wp )  THEN
-
-       IF (  .NOT.  ocean_mode )  THEN
-          DO  k = nzb+1, nzt
-             IF ( zu(k) >= rayleigh_damping_height )  THEN
-                rdf(k) = rayleigh_damping_factor *                                                 &
-                         ( SIN( pi * 0.5_wp * ( zu(k) - rayleigh_damping_height )                  &
-                                / ( zu(nzt) - rayleigh_damping_height ) )                          &
-                         )**2
-             ENDIF
-          ENDDO
-       ELSE
-!
-!--       In ocean mode, rayleigh damping is applied in the lower part of the model domain
-          DO  k = nzt, nzb+1, -1
-             IF ( zu(k) <= rayleigh_damping_height )  THEN
-                rdf(k) = rayleigh_damping_factor *                                                 &
-                         ( SIN( pi * 0.5_wp * ( rayleigh_damping_height - zu(k) )                  &
-                                / ( rayleigh_damping_height - zu(nzb+1) ) )                        &
-                         )**2
-             ENDIF
-          ENDDO
-       ENDIF
-
-    ENDIF
-    IF ( scalar_rayleigh_damping )  rdf_sc = rdf
-
-!
-!-- Initialize the starting level and the vertical smoothing factor used for the external pressure
-!-- gradient
-    dp_smooth_factor = 1.0_wp
-    IF ( dp_external )  THEN
-!
-!--    Set the starting level dp_level_ind_b only if it has not been set before (e.g. in init_grid).
-       IF ( dp_level_ind_b == 0 )  THEN
-          ind_array = MINLOC( ABS( dp_level_b - zu ) )
-          dp_level_ind_b = ind_array(1) - 1 + nzb
-                                        ! MINLOC uses lower array bound 1
-       ENDIF
-       IF ( dp_smooth )  THEN
-          dp_smooth_factor(:dp_level_ind_b) = 0.0_wp
-          DO  k = dp_level_ind_b+1, nzt
-             dp_smooth_factor(k) = 0.5_wp * ( 1.0_wp + SIN( pi *                                   &
-                                             ( REAL( k - dp_level_ind_b, KIND=wp ) /               &
-                                               REAL( nzt - dp_level_ind_b, KIND=wp ) - 0.5_wp ) ) )
-          ENDDO
-       ENDIF
-    ENDIF
-
-!
-!-- Initialize damping zone for the potential temperature in case of non-cyclic lateral boundaries.
-!-- The damping zone has the maximum value at the inflow boundary and decreases to zero at
-!-- pt_damping_width.
-    ptdf_x = 0.0_wp
-    ptdf_y = 0.0_wp
-    IF ( bc_lr_dirrad )  THEN
-       DO  i = nxl, nxr
-          IF ( ( i * dx ) < pt_damping_width )  THEN
-             ptdf_x(i) = pt_damping_factor * ( SIN( pi * 0.5_wp *                                  &
-                                                    REAL( pt_damping_width - i * dx, KIND=wp ) /   &
-                                                    REAL( pt_damping_width, KIND=wp ) ) )**2
-                                  ENDIF
-       ENDDO
-    ELSEIF ( bc_lr_raddir )  THEN
-       DO  i = nxl, nxr
-          IF ( ( i * dx ) > ( nx * dx - pt_damping_width ) )  THEN
-             ptdf_x(i) = pt_damping_factor * SIN( pi * 0.5_wp *                                    &
-                                                  ( ( i - nx ) * dx + pt_damping_width ) /         &
-                                                  REAL( pt_damping_width, KIND=wp ) )**2
-          ENDIF
-       ENDDO
-    ELSEIF ( bc_ns_dirrad )  THEN
-       DO  j = nys, nyn
-          IF ( ( j * dy ) > ( ny * dy - pt_damping_width ) )  THEN
-             ptdf_y(j) = pt_damping_factor * SIN( pi * 0.5_wp *                                    &
-                                                  ( ( j - ny ) * dy + pt_damping_width ) /         &
-                                                  REAL( pt_damping_width, KIND=wp ) )**2
-          ENDIF
-       ENDDO
-    ELSEIF ( bc_ns_raddir )  THEN
-       DO  j = nys, nyn
-          IF ( ( j * dy ) < pt_damping_width )  THEN
-             ptdf_y(j) = pt_damping_factor * SIN( pi * 0.5_wp *                                    &
-                                                  ( pt_damping_width - j * dy ) /                  &
-                                                  REAL( pt_damping_width, KIND=wp ) )**2
-          ENDIF
-       ENDDO
-    ENDIF
-
-!
-!-- Input binary data file is not needed anymore. This line must be placed after call of user_init!
-    CALL close_file( 13 )
-!
-!-- In case of nesting, put an barrier to assure that all parent and child domains finished
-!-- initialization.
-#if defined( __parallel )
-    IF ( nested_run )  CALL MPI_BARRIER( MPI_COMM_WORLD, ierr )
-#endif
-
-
-    CALL location_message( 'model initialization', 'finished' )
+    ngp_3d = ngp_2dh * ( nz + 2 )
+
+!
+!-- Set a lower limit of 1 in order to avoid zero divisions in flow_statistics,
+!-- buoyancy, etc. A zero value will occur for cases where all grid points of
+!-- the respective subdomain lie below the surface topography
+    ngp_2dh_outer = MAX( 1, ngp_2dh_outer(:,:) ) 
+    ngp_3d_inner  = MAX( 1, ngp_3d_inner(:)    )
+
+    DEALLOCATE( ngp_2dh_l, ngp_2dh_outer_l, ngp_3d_inner_l )
+
 
  END SUBROUTINE init_3d_model
Index: palm/trunk/SOURCE/init_advec.f90
===================================================================
--- palm/trunk/SOURCE/init_advec.f90	(revision 4901)
+++ palm/trunk/SOURCE/init_advec.f90	(revision 1)
@@ -1,34 +1,27 @@
-!> @file init_advec.f90
-!--------------------------------------------------------------------------------------------------!
-! This file is part of the PALM model system.
-!
-! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
-! Public License as published by the Free Software Foundation, either version 3 of the License, or
-! (at your option) any later version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
-! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
-! Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with PALM. If not, see
-! <http://www.gnu.org/licenses/>.
-!
-! Copyright 1997-2021 Leibniz Universitaet Hannover
-!--------------------------------------------------------------------------------------------------!
-!
-! Current revisions:
+ SUBROUTINE init_advec
+
+!------------------------------------------------------------------------------!
+! Actual revisions:
 ! -----------------
-!
+! 
 !
 ! Former revisions:
 ! -----------------
-! $Id$
-! file re-formatted to follow the PALM coding standard
-!
-! 4360 2020-01-07 11:25:50Z suehring
-! Corrected "Former revisions" section
-!
-! 3655 2019-01-07 16:51:22Z knoop
-! Corrected "Former revisions" section
+! $Log: init_advec.f90,v $
+! Revision 1.6  2004/04/30 11:59:31  raasch
+! impulse_advec renamed momentum_advec
+!
+! Revision 1.5  2001/03/30 07:25:53  raasch
+! Translation of remaining German identifiers (variables, subroutines, etc.)
+!
+! Revision 1.4  2001/01/22 06:57:43  raasch
+! Module test_variables removed
+!
+! Revision 1.3  2000/12/21 16:12:52  letzel
+! All comments translated into English.
+!
+! Revision 1.2  1999/02/17 09:18:45  raasch
+! Fehlerkorrektur, Verfahren muessen unabhaengig voneinander initialisierbar
+! sein
 !
 ! Revision 1.1  1999/02/05 09:07:38  raasch
@@ -38,33 +31,18 @@
 ! Description:
 ! ------------
-!> Initialize constant coefficients and parameters for certain advection schemes.
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE init_advec
-
-
-    USE advection,                                                                                 &
-        ONLY:  aex, bex, dex, eex
-
-    USE kinds
-
-    USE control_parameters,                                                                        &
-        ONLY:  scalar_advec
+! Initialize constant coefficients and parameters for certain advection schemes.
+!------------------------------------------------------------------------------!
+
+    USE advection
+    USE arrays_3d
+    USE indices
+    USE control_parameters
 
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  i          !<
-    INTEGER(iwp) ::  intervals  !<
-    INTEGER(iwp) ::  j          !<
-
-    REAL(wp) :: delt   !<
-    REAL(wp) :: dn     !<
-    REAL(wp) :: dnneu  !<
-    REAL(wp) :: ex1    !<
-    REAL(wp) :: ex2    !<
-    REAL(wp) :: ex3    !<
-    REAL(wp) :: ex4    !<
-    REAL(wp) :: ex5    !<
-    REAL(wp) :: ex6    !<
-    REAL(wp) :: sterm  !<
+    INTEGER :: i, intervals, j, k
+    REAL    :: delt, dn, dnneu, ex1, ex2, ex3, ex4, ex5, ex6, spl_alpha, &
+               spl_beta, sterm
+    REAL, DIMENSION(:), ALLOCATABLE ::  spl_u, temp
 
 
@@ -76,20 +54,20 @@
        ALLOCATE( aex(intervals), bex(intervals), dex(intervals), eex(intervals) )
 
-       delt  = 1.0_wp / REAL( intervals, KIND=wp )
-       sterm = delt * 0.5_wp
+       delt  = 1.0 / REAL( intervals )
+       sterm = delt * 0.5
 
        DO  i = 1, intervals
 
-          IF ( sterm > 0.5_wp )  THEN
-             dn = -5.0_wp
+          IF ( sterm > 0.5 )  THEN
+             dn = -5.0
           ELSE
-             dn = 5.0_wp
+             dn = 5.0
           ENDIF
 
           DO  j = 1, 15
-             ex1 = dn * EXP( -dn ) - EXP( 0.5_wp * dn ) + EXP( -0.5_wp * dn )
+             ex1 = dn * EXP( -dn ) - EXP( 0.5 * dn ) + EXP( -0.5 * dn )
              ex2 = EXP( dn ) - EXP( -dn )
-             ex3 = EXP( -dn ) * ( 1.0_wp - dn ) - 0.5_wp * EXP(  0.5_wp * dn )                     &
-                                                - 0.5_wp * EXP( -0.5_wp * dn )
+             ex3 = EXP( -dn ) * ( 1.0 - dn ) - 0.5 * EXP(  0.5 * dn ) &
+                                             - 0.5 * EXP( -0.5 * dn )
              ex4 = EXP( dn ) + EXP( -dn )
              ex5 = dn * sterm + ex1 / ex2
@@ -99,12 +77,12 @@
           ENDDO
 
-          IF ( sterm < 0.5_wp )  dn = MAX(  2.95E-2_wp, dn )
-          IF ( sterm > 0.5_wp )  dn = MIN( -2.95E-2_wp, dn )
+          IF ( sterm < 0.5 )  dn = MAX(  2.95E-2, dn )
+          IF ( sterm > 0.5 )  dn = MIN( -2.95E-2, dn )
           ex1 = EXP( -dn )
           ex2 = EXP( dn ) - ex1
           aex(i) = -ex1 / ex2
-          bex(i) = 1.0_wp / ex2
+          bex(i) = 1.0 / ex2
           dex(i) = dn
-          eex(i) = EXP( dex(i) * 0.5_wp )
+          eex(i) = EXP( dex(i) * 0.5 )
           sterm = sterm + delt
 
@@ -113,3 +91,157 @@
     ENDIF
 
+    IF ( momentum_advec == 'ups-scheme' .OR. scalar_advec  == 'ups-scheme' )  &
+    THEN
+
+!
+!--    Provide the constant parameters for the Upstream-Spline advection scheme.
+!--    In x- und y-direction the Sherman-Morrison formula is applied
+!--    (cf. Press et al, 1986 (Numerical Recipes)).
+!
+!--    Allocate nonlocal arrays
+       ALLOCATE( spl_z_x(0:nx), spl_z_y(0:ny), spl_tri_x(5,0:nx), &
+                 spl_tri_y(5,0:ny), spl_tri_zu(5,nzb:nzt+1),      &
+                 spl_tri_zw(5,nzb:nzt+1) )
+
+!
+!--    Provide diagonal elements of the tridiagonal matrices for all 
+!--    directions
+       spl_tri_x(1,:)  = 2.0
+       spl_tri_y(1,:)  = 2.0
+       spl_tri_zu(1,:) = 2.0
+       spl_tri_zw(1,:) = 2.0
+
+!
+!--    Elements of the cyclic tridiagonal matrix
+!--    (same for all horizontal directions)
+       spl_alpha = 0.5
+       spl_beta  = 0.5
+
+!
+!--    Sub- and superdiagonal elements, x-direction
+       spl_tri_x(2,0:nx) = 0.5
+       spl_tri_x(3,0:nx) = 0.5
+
+!
+!--    mMdify the diagonal elements (Sherman-Morrison)
+       spl_gamma_x    = -spl_tri_x(1,0)
+       spl_tri_x(1,0)  = spl_tri_x(1,0) - spl_gamma_x
+       spl_tri_x(1,nx) = spl_tri_x(1,nx) - spl_alpha * spl_beta / spl_gamma_x
+
+!
+!--    Split the tridiagonal matrix for Thomas algorithm
+       spl_tri_x(4,0) = spl_tri_x(1,0)
+       DO  i = 1, nx
+          spl_tri_x(5,i) = spl_tri_x(2,i) / spl_tri_x(4,i-1)
+          spl_tri_x(4,i) = spl_tri_x(1,i) - spl_tri_x(5,i) * spl_tri_x(3,i-1)
+       ENDDO
+
+!
+!--    Allocate arrays required locally
+       ALLOCATE( temp(0:nx), spl_u(0:nx) )
+
+!
+!--    Provide "corrective vector", x-direction
+       spl_u(0)      = spl_gamma_x
+       spl_u(1:nx-1) = 0.0
+       spl_u(nx)     = spl_alpha
+
+!
+!--    Solve the system of equations for the corrective vector
+!--    (Sherman-Morrison)
+       temp(0) = spl_u(0)
+       DO  i = 1, nx
+          temp(i) = spl_u(i) - spl_tri_x(5,i) * temp(i-1)
+       ENDDO
+       spl_z_x(nx) = temp(nx) / spl_tri_x(4,nx)
+       DO  i = nx-1, 0, -1
+          spl_z_x(i) = ( temp(i) - spl_tri_x(3,i) * spl_z_x(i+1) ) / &
+                       spl_tri_x(4,i)
+       ENDDO
+
+!
+!--    Deallocate local arrays, for they are allocated in a different way for
+!--    operations in y-direction
+       DEALLOCATE( temp, spl_u )    
+    
+!
+!--    Provide sub- and superdiagonal elements, y-direction
+       spl_tri_y(2,0:ny) = 0.5
+       spl_tri_y(3,0:ny) = 0.5
+
+!
+!--    Modify the diagonal elements (Sherman-Morrison)
+       spl_gamma_y    = -spl_tri_y(1,0) 
+       spl_tri_y(1,0)  = spl_tri_y(1,0) - spl_gamma_y
+       spl_tri_y(1,ny) = spl_tri_y(1,ny) - spl_alpha * spl_beta / spl_gamma_y
+
+!
+!--    Split the tridiagonal matrix for Thomas algorithm
+       spl_tri_y(4,0) = spl_tri_y(1,0)
+       DO  j = 1, ny
+          spl_tri_y(5,j) = spl_tri_y(2,j) / spl_tri_y(4,j-1)
+          spl_tri_y(4,j) = spl_tri_y(1,j) - spl_tri_y(5,j) * spl_tri_y(3,j-1)
+       ENDDO
+
+!
+!--    Allocate arrays required locally
+       ALLOCATE( temp(0:ny), spl_u(0:ny) )
+
+!
+!--    Provide "corrective vector", y-direction
+       spl_u(0)      = spl_gamma_y
+       spl_u(1:ny-1) = 0.0
+       spl_u(ny)     = spl_alpha
+    
+!
+!--    Solve the system of equations for the corrective vector
+!--    (Sherman-Morrison)
+       temp = 0.0
+       spl_z_y = 0.0
+       temp(0) = spl_u(0)
+       DO  j = 1, ny
+          temp(j) = spl_u(j) - spl_tri_y(5,j) * temp(j-1)
+       ENDDO
+       spl_z_y(ny) = temp(ny) / spl_tri_y(4,ny)
+       DO  j = ny-1, 0, -1
+          spl_z_y(j) = ( temp(j) - spl_tri_y(3,j) * spl_z_y(j+1) ) / &
+                       spl_tri_y(4,j)
+       ENDDO
+
+!
+!--    deallocate local arrays, for they are no longer required
+       DEALLOCATE( temp, spl_u )
+
+!
+!--    provide sub- and superdiagonal elements, z-direction
+       spl_tri_zu(2,nzb)   = 0.0
+       spl_tri_zu(2,nzt+1) = 1.0
+       spl_tri_zw(2,nzb)   = 0.0
+       spl_tri_zw(2,nzt+1) = 1.0
+
+       spl_tri_zu(3,nzb)   = 1.0
+       spl_tri_zu(3,nzt+1) = 0.0
+       spl_tri_zw(3,nzb)   = 1.0
+       spl_tri_zw(3,nzt+1) = 0.0
+
+       DO  k = nzb+1, nzt
+          spl_tri_zu(2,k) = dzu(k) / ( dzu(k) + dzu(k+1) )
+          spl_tri_zw(2,k) = dzw(k) / ( dzw(k) + dzw(k+1) )
+          spl_tri_zu(3,k) = 1.0 - spl_tri_zu(2,k)
+          spl_tri_zw(3,k) = 1.0 - spl_tri_zw(2,k)
+       ENDDO
+    
+       spl_tri_zu(4,nzb) = spl_tri_zu(1,nzb)
+       spl_tri_zw(4,nzb) = spl_tri_zw(1,nzb)
+       DO  k = nzb+1, nzt+1
+          spl_tri_zu(5,k) = spl_tri_zu(2,k) / spl_tri_zu(4,k-1)
+          spl_tri_zw(5,k) = spl_tri_zw(2,k) / spl_tri_zw(4,k-1)
+          spl_tri_zu(4,k) = spl_tri_zu(1,k) - spl_tri_zu(5,k) * &
+                            spl_tri_zu(3,k-1)
+          spl_tri_zw(4,k) = spl_tri_zw(1,k) - spl_tri_zw(5,k) * &
+                            spl_tri_zw(3,k-1)
+       ENDDO
+
+    ENDIF
+
  END SUBROUTINE init_advec
Index: palm/trunk/SOURCE/init_cloud_physics.f90
===================================================================
--- palm/trunk/SOURCE/init_cloud_physics.f90	(revision 1)
+++ palm/trunk/SOURCE/init_cloud_physics.f90	(revision 1)
@@ -0,0 +1,79 @@
+ SUBROUTINE init_cloud_physics
+
+!------------------------------------------------------------------------------!
+! Actual revisions:
+! -----------------
+! 
+!
+! Former revisions:
+! ------------------
+! $Log: init_cloud_physics.f90,v $
+! Revision 1.5  2005/06/26 19:55:58  raasch
+! Initialization of cloud droplet constants, gas_constant renamed r_d,
+! latent_heat renamed l_v
+!
+! Revision 1.4  2001/03/30 07:26:30  raasch
+! Translation of remaining German identifiers (variables, subroutines, etc.),
+! surface_pressure keeps unit hPa and is not converted to Pa
+!
+! Revision 1.3  2001/01/25 07:03:10  raasch
+! Module test_variables removed
+!
+! Revision 1.2  2001/01/22 09:16:57  schroeter
+! To calculate verticle pressure profile use actual surface-temperature in
+! place of potential temperature as reference value.
+!
+! Revision 1.1  2000/04/13 14:37:22  schroeter
+! Initial revision
+!
+!
+! Description:
+! ------------
+! Initialization of parameters for handling cloud-physics
+!------------------------------------------------------------------------------!
+
+    USE arrays_3d
+    USE cloud_parameters
+    USE control_parameters
+    USE grid_variables
+    USE indices
+
+    IMPLICIT NONE
+
+    INTEGER ::  k
+    REAL    ::  t_surface
+
+    ALLOCATE( hydro_press(nzb:nzt+1), pt_d_t(nzb:nzt+1), t_d_pt(nzb:nzt+1) )
+
+!
+!-- Compute frequently used parameters
+    l_d_cp = l_v / cp
+    l_d_r  = l_v / r_d
+    l_d_rv = l_v / r_v
+
+!
+!-- Constant b in equation for droplet growth by condensation / evaporation.
+!-- Factor 1E-3 is needed because formula is in cgs units
+    mass_of_solute = 1.0E-17            ! in kg
+    molecular_weight_of_solute = 58.5   ! NaCl
+    b_cond = 4.3 * 2.0 * mass_of_solute / molecular_weight_of_solute * 1.0E-6
+
+!
+!-- Calculate:
+!-- pt / t : ratio of potential and actual temperature (pt_d_t)
+!-- t / pt : ratio of actual and potential temperature (t_d_pt)
+!-- p_0(z) : vertical profile of the hydrostatic pressure (hydro_press)
+    t_surface = pt_surface * ( surface_pressure / 1000.0 )**0.286
+    DO  k = nzb, nzt+1
+       hydro_press(k) = surface_pressure * 100.0 * &
+                        ( (t_surface - g/cp * zu(k)) / t_surface )**(1.0/0.286)
+       pt_d_t(k)      = ( 100000.0 / hydro_press(k) )**0.286
+       t_d_pt(k)      = 1.0 / pt_d_t(k)       
+    ENDDO
+
+!
+!-- Compute reference density
+    rho_surface = surface_pressure * 100.0 / ( r_d * t_surface )
+
+
+ END SUBROUTINE init_cloud_physics
